Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/AccessAdministrationClient.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/AccessAdministrationClient.cs	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/AccessAdministrationClient.cs	(revision 7635)
@@ -43,4 +43,6 @@
       }
     }
+
+    public ItemList<UserGroup> Groups { get; set; }
     #endregion
 
@@ -48,28 +50,22 @@
 
     #region Refresh
-    public void Refresh() {
+    public void RefreshUsers() {
       users = new ItemList<User>();
       users.AddRange(CallAccessService<ItemList<User>>(s => new ItemList<User>(s.GetAllUsers())));
     }
 
-    public void RefreshAsync(Action<Exception> exceptionCallback) {
-      var call = new Func<Exception>(delegate() {
-        try {
-          OnRefreshing();
-          Refresh();
-        }
-        catch (Exception ex) {
-          return ex;
-        }
-        finally {
-          OnRefreshed();
-        }
-        return null;
-      });
-      call.BeginInvoke(delegate(IAsyncResult result) {
-        Exception ex = call.EndInvoke(result);
-        if (ex != null) exceptionCallback(ex);
-      }, null);
+    public void RefreshUsersAsync(Action<Exception> exceptionCallback) {
+      ExecuteActionAsync(RefreshUsers, exceptionCallback);
     }
+
+    public void RefreshUserGroups() {
+      Groups = new ItemList<UserGroup>();
+      Groups.AddRange(CallAccessService<ItemList<UserGroup>>(s => new ItemList<UserGroup>(s.GetAllUserGroups())));
+    }
+
+    public void RefreshUserGroupsAsync(Action<Exception> exceptionCallback) {
+      ExecuteActionAsync(RefreshUserGroups, exceptionCallback);
+    }
+
     public void ExecuteActionAsync(Action action, Action<Exception> exceptionCallback) {
       var call = new Func<Exception>(delegate() {
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/HeuristicLab.Clients.Access.Administration-3.3.csproj
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/HeuristicLab.Clients.Access.Administration-3.3.csproj	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/HeuristicLab.Clients.Access.Administration-3.3.csproj	(revision 7635)
@@ -129,4 +129,28 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Views\UserGroupListView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\UserGroupListView.Designer.cs">
+      <DependentUpon>UserGroupListView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\RefreshableUserGroupListView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\RefreshableUserGroupListView.Designer.cs">
+      <DependentUpon>RefreshableUserGroupListView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\UserGroupView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\UserGroupView.Designer.cs">
+      <DependentUpon>UserGroupView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\RoleView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\RoleView.Designer.cs">
+      <DependentUpon>RoleView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\RefreshableUserListView.cs">
       <SubType>UserControl</SubType>
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs	(revision 7635)
@@ -0,0 +1,60 @@
+﻿namespace HeuristicLab.Clients.Access.Administration {
+  partial class RefreshableUserGroupListView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.userGroupListView = new HeuristicLab.Clients.Access.Administration.UserGroupListView();
+      this.SuspendLayout();
+      // 
+      // userGroupListView
+      // 
+      this.userGroupListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.userGroupListView.Caption = "UserGroupList View";
+      this.userGroupListView.Content = null;
+      this.userGroupListView.Location = new System.Drawing.Point(3, 33);
+      this.userGroupListView.Name = "userGroupListView";
+      this.userGroupListView.ReadOnly = false;
+      this.userGroupListView.Size = new System.Drawing.Size(559, 375);
+      this.userGroupListView.TabIndex = 2;
+      // 
+      // RefreshableUserGroupListView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.userGroupListView);
+      this.Name = "RefreshableUserGroupListView";
+      this.Size = new System.Drawing.Size(565, 411);
+      this.Controls.SetChildIndex(this.userGroupListView, 0);
+      this.Controls.SetChildIndex(this.refreshButton, 0);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private UserGroupListView userGroupListView;
+
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.cs	(revision 7635)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+namespace HeuristicLab.Clients.Access.Administration {
+  public partial class RefreshableUserGroupListView : RefreshableView {
+    public RefreshableUserGroupListView() {
+      InitializeComponent();
+    }
+
+    protected override void RefreshData() {
+      Content.RefreshUserGroupsAsync(PluginInfrastructure.ErrorHandling.ShowErrorDialog);
+    }
+
+    protected override void Content_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_Refreshing), sender, e);
+      } else {
+        base.Content_Refreshing(sender, e);
+        userGroupListView.Enabled = false;
+      }
+    }
+
+    protected override void Content_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_Refreshed), sender, e);
+      } else {
+        base.Content_Refreshed(sender, e);
+        userGroupListView.Enabled = true;
+        userGroupListView.Content = Content.Groups;
+      }
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.cs	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.cs	(revision 7635)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 namespace HeuristicLab.Clients.Access.Administration {
   public partial class RefreshableUserListView : RefreshableView {
@@ -27,9 +28,25 @@
 
     protected override void RefreshData() {
-      Content.Refresh();
-      userListView.Content = Content.Users;
+      Content.RefreshUsersAsync(PluginInfrastructure.ErrorHandling.ShowErrorDialog);
     }
 
+    protected override void Content_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_Refreshing), sender, e);
+      } else {
+        base.Content_Refreshing(sender, e);
+        userListView.Enabled = false;
+      }
+    }
 
+    protected override void Content_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_Refreshed), sender, e);
+      } else {
+        base.Content_Refreshed(sender, e);
+        userListView.Enabled = true;
+        userListView.Content = Content.Users;
+      }
+    }
   }
 }
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.Designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.Designer.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.Designer.cs	(revision 7635)
@@ -0,0 +1,66 @@
+﻿namespace HeuristicLab.Clients.Access.Administration {
+  partial class RoleView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.label2 = new System.Windows.Forms.Label();
+      this.roleNameTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(3, 6);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(63, 13);
+      this.label2.TabIndex = 1;
+      this.label2.Text = "Role Name:";
+      // 
+      // roleNameTextBox
+      // 
+      this.roleNameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.roleNameTextBox.Location = new System.Drawing.Point(75, 3);
+      this.roleNameTextBox.Name = "roleNameTextBox";
+      this.roleNameTextBox.Size = new System.Drawing.Size(289, 20);
+      this.roleNameTextBox.TabIndex = 3;
+      // 
+      // RoleView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.roleNameTextBox);
+      this.Controls.Add(this.label2);
+      this.Name = "RoleView";
+      this.Size = new System.Drawing.Size(364, 27);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.TextBox roleNameTextBox;
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RoleView.cs	(revision 7635)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.Access.Administration {
+  [View("Role View")]
+  [Content(typeof(Role), true)]
+  public partial class RoleView : ItemView {
+    public new Role Content {
+      get { return (Role)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public RoleView() {
+      InitializeComponent();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+
+      if (Content == null) {
+        roleNameTextBox.Clear();
+      } else {
+        roleNameTextBox.Text = Content.Name;
+      }
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.Designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.Designer.cs	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.Designer.cs	(revision 7635)
@@ -25,18 +25,73 @@
     private void InitializeComponent() {
       this.refreshableUserListView = new HeuristicLab.Clients.Access.Administration.RefreshableUserListView();
+      this.mainTabControl = new System.Windows.Forms.TabControl();
+      this.usersTabPage = new System.Windows.Forms.TabPage();
+      this.UserGroupsTabPage = new System.Windows.Forms.TabPage();
+      this.refreshableUserGroupListView = new HeuristicLab.Clients.Access.Administration.RefreshableUserGroupListView();
+      this.mainTabControl.SuspendLayout();
+      this.usersTabPage.SuspendLayout();
+      this.UserGroupsTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
       // refreshableUserListView
       // 
-      this.refreshableUserListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.refreshableUserListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.refreshableUserListView.Caption = "View";
       this.refreshableUserListView.Content = null;
-      this.refreshableUserListView.Location = new System.Drawing.Point(12, 12);
+      this.refreshableUserListView.Location = new System.Drawing.Point(6, 6);
       this.refreshableUserListView.Name = "refreshableUserListView";
       this.refreshableUserListView.ReadOnly = false;
-      this.refreshableUserListView.Size = new System.Drawing.Size(782, 402);
+      this.refreshableUserListView.Size = new System.Drawing.Size(762, 364);
       this.refreshableUserListView.TabIndex = 0;
+      // 
+      // mainTabControl
+      // 
+      this.mainTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.mainTabControl.Controls.Add(this.usersTabPage);
+      this.mainTabControl.Controls.Add(this.UserGroupsTabPage);
+      this.mainTabControl.Location = new System.Drawing.Point(12, 12);
+      this.mainTabControl.Name = "mainTabControl";
+      this.mainTabControl.SelectedIndex = 0;
+      this.mainTabControl.Size = new System.Drawing.Size(782, 402);
+      this.mainTabControl.TabIndex = 1;
+      // 
+      // usersTabPage
+      // 
+      this.usersTabPage.Controls.Add(this.refreshableUserListView);
+      this.usersTabPage.Location = new System.Drawing.Point(4, 22);
+      this.usersTabPage.Name = "usersTabPage";
+      this.usersTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.usersTabPage.Size = new System.Drawing.Size(774, 376);
+      this.usersTabPage.TabIndex = 0;
+      this.usersTabPage.Text = "Users";
+      this.usersTabPage.UseVisualStyleBackColor = true;
+      // 
+      // UserGroupsTabPage
+      // 
+      this.UserGroupsTabPage.Controls.Add(this.refreshableUserGroupListView);
+      this.UserGroupsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.UserGroupsTabPage.Name = "UserGroupsTabPage";
+      this.UserGroupsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.UserGroupsTabPage.Size = new System.Drawing.Size(774, 376);
+      this.UserGroupsTabPage.TabIndex = 1;
+      this.UserGroupsTabPage.Text = "Groups";
+      this.UserGroupsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // refreshableUserGroupListView
+      // 
+      this.refreshableUserGroupListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.refreshableUserGroupListView.Caption = "View";
+      this.refreshableUserGroupListView.Content = null;
+      this.refreshableUserGroupListView.Location = new System.Drawing.Point(6, 6);
+      this.refreshableUserGroupListView.Name = "refreshableUserGroupListView";
+      this.refreshableUserGroupListView.ReadOnly = false;
+      this.refreshableUserGroupListView.Size = new System.Drawing.Size(762, 364);
+      this.refreshableUserGroupListView.TabIndex = 0;
       // 
       // UserAdministrationDialog
@@ -45,5 +100,5 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.ClientSize = new System.Drawing.Size(806, 426);
-      this.Controls.Add(this.refreshableUserListView);
+      this.Controls.Add(this.mainTabControl);
       this.MaximizeBox = false;
       this.MinimizeBox = false;
@@ -54,4 +109,7 @@
       this.Text = "User Administration";
       this.Load += new System.EventHandler(this.UserAdministrationDialog_Load);
+      this.mainTabControl.ResumeLayout(false);
+      this.usersTabPage.ResumeLayout(false);
+      this.UserGroupsTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -61,4 +119,8 @@
 
     private RefreshableUserListView refreshableUserListView;
+    private System.Windows.Forms.TabControl mainTabControl;
+    private System.Windows.Forms.TabPage usersTabPage;
+    private System.Windows.Forms.TabPage UserGroupsTabPage;
+    private RefreshableUserGroupListView refreshableUserGroupListView;
   }
 }
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.cs	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserAdministrationDialog.cs	(revision 7635)
@@ -31,4 +31,5 @@
       if (!DesignMode) {
         refreshableUserListView.Content = AccessAdministrationClient.Instance;
+        refreshableUserGroupListView.Content = AccessAdministrationClient.Instance;
       }
     }
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.Designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.Designer.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.Designer.cs	(revision 7635)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Clients.Access.Administration {
+  partial class UserGroupListView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupListView.cs	(revision 7635)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Clients.Access.Administration {
+  [View("UserGroupList View")]
+  [Content(typeof(IItemList<UserGroup>), true)]
+  public partial class UserGroupListView : ItemListView<UserGroup> {
+    public UserGroupListView() {
+      InitializeComponent();
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs	(revision 7635)
@@ -0,0 +1,90 @@
+﻿namespace HeuristicLab.Clients.Access.Administration {
+  partial class UserGroupView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.label1 = new System.Windows.Forms.Label();
+      this.label2 = new System.Windows.Forms.Label();
+      this.groupNameTextBox = new System.Windows.Forms.TextBox();
+      this.idTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 6);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(70, 13);
+      this.label1.TabIndex = 0;
+      this.label1.Text = "Group Name:";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(3, 32);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(19, 13);
+      this.label2.TabIndex = 1;
+      this.label2.Text = "Id:";
+      // 
+      // groupNameTextBox
+      // 
+      this.groupNameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.groupNameTextBox.Location = new System.Drawing.Point(79, 3);
+      this.groupNameTextBox.Name = "groupNameTextBox";
+      this.groupNameTextBox.Size = new System.Drawing.Size(282, 20);
+      this.groupNameTextBox.TabIndex = 2;
+      // 
+      // idTextBox
+      // 
+      this.idTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.idTextBox.Location = new System.Drawing.Point(79, 29);
+      this.idTextBox.Name = "idTextBox";
+      this.idTextBox.Size = new System.Drawing.Size(282, 20);
+      this.idTextBox.TabIndex = 3;
+      // 
+      // UserGroupView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.idTextBox);
+      this.Controls.Add(this.groupNameTextBox);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.label1);
+      this.Name = "UserGroupView";
+      this.Size = new System.Drawing.Size(364, 54);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.TextBox groupNameTextBox;
+    private System.Windows.Forms.TextBox idTextBox;
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.cs	(revision 7635)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.cs	(revision 7635)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.Access.Administration {
+  [View("UserGroup View")]
+  [Content(typeof(UserGroup), true)]
+  public partial class UserGroupView : ItemView {
+    public new UserGroup Content {
+      get { return (UserGroup)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public UserGroupView() {
+      InitializeComponent();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+
+      if (Content == null) {
+        groupNameTextBox.Clear();
+        idTextBox.Clear();
+      } else {
+        groupNameTextBox.Text = Content.Name;
+        idTextBox.Text = Content.Id.ToString();
+      }
+    }
+  }
+}
Index: /branches/ClientUserManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightUserInformationView.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightUserInformationView.cs	(revision 7634)
+++ /branches/ClientUserManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightUserInformationView.cs	(revision 7635)
@@ -34,10 +34,6 @@
     }
 
-    private void DisplayError(Exception ex) {
-      PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
-    }
-
     protected override void RefreshData() {
-      Content.ExecuteActionAsync(RefreshUserData, DisplayError);
+      Content.ExecuteActionAsync(RefreshUserData, PluginInfrastructure.ErrorHandling.ShowErrorDialog);
     }
 