Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.cs	(revision 7660)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddAzureServiceDialog.cs	(revision 7661)
@@ -122,5 +122,5 @@
         Subscription subscription = (Subscription)cmbChooseSubscription.SelectedItem;
         if (subscription.CurrentHostedServices == subscription.MaxHostedServices) {
-          MessageBox.Show("You have already created the maximum number of hosted services", "Limit Reached", MessageBoxButtons.OK, MessageBoxIcon.Error);
+          PluginInfrastructure.ErrorHandling.ShowErrorDialog(new Exception("You have already created the maximum number of hosted services"));
           cbNewHostedService.Checked = false;
         } else {
@@ -264,5 +264,5 @@
       }
       catch (Exception ex) {
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
       }
     }
@@ -317,5 +317,5 @@
       catch (Exception ex) {
         errorOccured = true;
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
       }
 
@@ -332,5 +332,5 @@
       catch (Exception ex) {
         errorOccured = true;
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
       }
 
@@ -348,5 +348,5 @@
       catch (Exception ex) {
         errorOccured = true;
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
       }
 
@@ -359,5 +359,5 @@
       catch (Exception ex) {
         errorOccured = true;
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
         if (newHostedServiceChecked) {
           CloudManagerClient.Instance.AzureProvider.DeleteHostedService(sub, hostedService.ServiceName);
@@ -375,5 +375,5 @@
       catch (Exception ex) {
         errorOccured = true;
-        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(ex);
         if (newHostedServiceChecked) {
           CloudManagerClient.Instance.AzureProvider.DeleteHostedService(sub, hostedService.ServiceName);
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddCertificate.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddCertificate.cs	(revision 7660)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddCertificate.cs	(revision 7661)
@@ -36,7 +36,7 @@
 
       if (CertificateFile.Length == 0) {
-        MessageBox.Show("Certificate file is required", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(new Exception("Certificate file is required"));
       } else if (CertificatePassword.Length == 0) {
-        MessageBox.Show("Password is required", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(new Exception("Password is required"));
       } else {
         SetControlsEnabled(false);
@@ -69,5 +69,5 @@
         this.Close();
       } else {
-        MessageBox.Show(e.Error.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(e.Error);
         CertificateFile = string.Empty;
         CertificateFile = string.Empty;
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddSubscriptionDialog.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddSubscriptionDialog.cs	(revision 7660)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/AddSubscriptionDialog.cs	(revision 7661)
@@ -56,5 +56,5 @@
         this.Close();
       } else {
-        MessageBox.Show(e.Error.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(e.Error);
         ErrorOccured = true;
         Subscription = null;
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteDeploymentView.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteDeploymentView.cs	(revision 7660)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteDeploymentView.cs	(revision 7661)
@@ -72,5 +72,5 @@
         this.Close();
       } else {
-        MessageBox.Show(e.Error.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(e.Error);
         ErrorOccured = true;
         this.Show();
Index: /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteHostedServiceView.cs
===================================================================
--- /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteHostedServiceView.cs	(revision 7660)
+++ /branches/HeuristicLab.Hive.Azure/HeuristicLab.Clients.Hive.CloudManager/3.3/Views/DeleteHostedServiceView.cs	(revision 7661)
@@ -62,5 +62,5 @@
         this.Close();
       } else {
-        MessageBox.Show(e.Error.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        PluginInfrastructure.ErrorHandling.ShowErrorDialog(e.Error);
         ErrorOccured = true;
         this.Show();